package com.xhpc.charging.station.utils.img;

import javax.imageio.ImageIO;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

/**
 * @Author WH
 * @Date 2021/9/10 17:44
 * @Description 图片工具拼接工具类
 * @Param
 * @Return
 * @Since version-1.0
 */
public class ImageUtil {

    private BufferedImage tempImg = null;

    public static void main(String[] args){

    }


    /**
     *
     * @param bottomFile 底图位置
     * @param qrcode 二维码位置
     * @param logo 底部Logo位置
     * @param serialNumber 终端编码
     * @param fullImgdestPath 最终生成的图片的存放位置
     * @param stationName 场站名称
     * @param pileNumber 桩号
     * @param letter 枪上的字母
     * @return boolean
     * @throws IOException
     */
    public boolean createXhImg(File bottomFile, File qrcode, File logo, String serialNumber, File fullImgdestPath, String stationName, String pileNumber, String letter){

        try {
            tempImg = this.createBottom(bottomFile);
            tempImg = this.addQrCodeToBottom(tempImg,qrcode);
            tempImg = this.addBottomLogo(tempImg,logo);
            tempImg = this.writeSerialNumber(tempImg,serialNumber);
            this.addHeader(tempImg,fullImgdestPath,stationName,pileNumber,letter);
            return true;
        } catch (IOException e) {
            e.printStackTrace();
        }
        return false;
    }

    /**
     *
     * @param source 合成了二维码、底部Logo、终端编号、头部的最终图
     * @param fullImgdestPath 最终生成的底图的存放位置
     * @param stationName 场站名称
     * @param pileNumber 终端编码
     * @param letter 枪上的字母
     * @return 添加了顶部文字的最终图片
     * @throws IOException
     */
    private void addHeader(BufferedImage source,File fullImgdestPath,String stationName,String pileNumber,String letter) throws IOException {

        Graphics2D g2 = source.createGraphics();
        g2.setColor(Color.BLACK);

        //写入桩部分
        writePile(source,stationName,pileNumber);
        //写入枪部分
        writeGun(source,letter);

        //生成的图片的存放路径
//        File dest = new File("D:\\Enterprise_Resources\\XiaoHuaQrImgs\\haha8.png");
        File dest = fullImgdestPath;

        ImageIO.write(source, "png", dest);
    }

    /**
     * 顶部文字右边部分
     * @param source 合成了二维码、底部Logo、终端编号、场站名称、桩号、枪部分的底图
     * @param letter 字母
     * @return 返回最终合成的图
     */
    private BufferedImage writeGun(BufferedImage source,String letter){
        Graphics2D g2 = source.createGraphics();
        g2.setColor(Color.WHITE);

        //提前设置文字参数，防止生成的文字带有锯齿
        g2.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);

        g2.setFont(new Font("黑体",Font.BOLD,130));
        g2.drawString(letter,250,180);
        g2.setFont(new Font("楷体",Font.BOLD,60));
        g2.drawString("枪",320,174);

        return source;
    }

    /**
     * 顶部文字左边部分，及其场站名称
     * @param source 合成了二维码、底部Logo、终端编码的底图
     * @param StationName 场站名称
     * @param PileNumber 桩号数字
     * @return source 合成了二维码、底部Logo、终端编码、场站名称、桩号的底图
     * @throws IOException
     */
    private BufferedImage writePile(BufferedImage source,String StationName,String PileNumber){
        Graphics2D g2 = source.createGraphics();
        g2.setColor(Color.WHITE);
        //提前设置文字参数，防止生成的文字带有锯齿
        g2.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);

        //在头顶设置场站名称：
        //在图片中居中显示文字
        String realStationName = StationName;                        //定义文字内容
        Font font=new Font("楷体",Font.PLAIN,24);         //设置文字大小
        g2.setFont(font);                                            //设置到画笔
        // 计算文字长度，计算居中的x点坐标
        FontMetrics fm = g2.getFontMetrics(font);                    //获取该大小字体的字体度量单位
        int textWidth = fm.stringWidth(realStationName);             //传入文字内容，让它计算出文字内容宽度
        int widthX = (400 - textWidth) / 2;                          //此处的400是图片的宽度用于计算出文字居中后的width
        // 表示这段文字在图片上的位置(x,y) 第一个是你设置的内容
        g2.drawString(realStationName,widthX,70);                 //此处的70是指放置居中后的文字的水平位置


        g2.setFont(new Font("楷体",Font.BOLD,48));
        g2.drawString(PileNumber+"号桩",25,154);

        return source;
    }

    /**
     *
     * @param source 合成了二维码、底部Logo的底图
     * @param SerialNumber 终端编码
     * @return 添加了终端编码的底图
     * @throws IOException
     */
    private BufferedImage writeSerialNumber(BufferedImage source,String SerialNumber){

        Graphics2D g2 = source.createGraphics();

        //提前设置文字参数，防止生成的文字带有锯齿
        g2.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);

        g2.setFont(new Font("楷体",Font.BOLD,24));
        g2.setColor(Color.WHITE);
        g2.drawRect(10,210,380,70);


        g2.drawString("终端编码："+SerialNumber,17,255);

        return source;
    }


    /**
     *
     * @param source 合成了二维码的底图
     * @param Logo 底图位置
     * @return 添加了底部Logo的底图
     * @throws IOException
     */
    private BufferedImage addBottomLogo(BufferedImage source,File Logo) throws IOException {

        //底部Logo存放位置
        File LogoImgPath = Logo;

        //使用ImageIO，将logo图片加载到内存中
        BufferedImage QrCodeImg = ImageIO.read(LogoImgPath);

        Graphics2D g2 = source.createGraphics();
        g2.drawImage(QrCodeImg,10,700,380,80,null);

        return source;
    }

    /**
     *
     * @param source 底图图片
     * @param QrCode 二维码存放位置
     * @return 添加了二维码的底图
     * @throws IOException
     */
    private BufferedImage addQrCodeToBottom(BufferedImage source,File QrCode) throws IOException {

        //二维码图片存放位置
        File QrCodeImgPath = QrCode;

        //使用ImageIO，将图片加载到内存中
        BufferedImage QrCodeImg = ImageIO.read(QrCodeImgPath);

        Graphics2D g2 = source.createGraphics();
        g2.drawImage(QrCodeImg,10,300,380,380,null);

        return source;
    }


    /**
     * 创建图片底图
     * @param bottomFile 底图文件
     * @return
     */
    private BufferedImage createBottom(File bottomFile) throws IOException {

        int width = 400;    //底图的宽
        int height = 800;   //底图的高

        //生成图片画布
        BufferedImage bi = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
        //生成用于该画布的画笔对象
        Graphics2D g2 = bi.createGraphics();

        //载入生成的二维码图片
        BufferedImage bottomImg = ImageIO.read(bottomFile);
        g2.drawImage(bottomImg,0,0,null);

        return bi;
    }

    /**
     * 快速生成完整图片，但可读性不高，属于一次性生成
     * @param bottomFile 底图
     * @param QrCode 生成的二维码图片
     * @param SerialNumber 终端编码
     * @throws IOException
     */
    public void fastCreateImg(File bottomFile,
                              File QrCode,
                              String SerialNumber,
                              String StationName,
                              String PileNumber,
                              String letter,
                              File fullImgdestPath) throws IOException {

        //载入生成的二维码图片
        BufferedImage bottomImg = ImageIO.read(bottomFile);
        //二维码图片存放位置
        File QrCodeImgPath = QrCode;
        //使用ImageIO，将图片加载到内存中
        BufferedImage QrCodeImg = ImageIO.read(QrCodeImgPath);

        Graphics2D g2 = bottomImg.createGraphics();
        g2.drawImage(QrCodeImg,10,300,380,380,null);

        //提前设置文字参数，防止生成的文字带有锯齿
        g2.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
        g2.setFont(new Font("楷体",Font.BOLD,24));
        g2.setColor(Color.WHITE);

        g2.drawString("终端编码："+SerialNumber,17,255);

        //在头顶设置场站名称：
        //在图片中居中显示文字
        String realStationName = StationName;                        //定义文字内容
        Font font=new Font("楷体",Font.PLAIN,24);         //设置文字大小
        g2.setFont(font);                                            //设置到画笔
        // 计算文字长度，计算居中的x点坐标
        FontMetrics fm = g2.getFontMetrics(font);                    //获取该大小字体的字体度量单位
        int textWidth = fm.stringWidth(realStationName);             //传入文字内容，让它计算出文字内容宽度
        int widthX = (400 - textWidth) / 2;                          //此处的400是图片的宽度用于计算出文字居中后的width
        // 表示这段文字在图片上的位置(x,y) 第一个是你设置的内容
        g2.drawString(realStationName,widthX,70);                 //此处的70是指放置居中后的文字的水平位置
        g2.setFont(new Font("楷体",Font.BOLD,48));

        g2.drawString(PileNumber+"号桩",25,154);

        g2.setFont(new Font("楷体", Font.BOLD, 130));
        g2.drawString(letter, 250, 180);
        g2.setFont(new Font("楷体",Font.BOLD,60));
        //g2.drawString("枪",320,174);

        File dest = fullImgdestPath;

        ImageIO.write(bottomImg, "png", dest);
    }
}
